proc change_fmt {} {
global entree 
global f

regsub gif|pgm|ppm|tif|jpg|bmp $entree(result) $entree(format) entree(result)
}

proc Select_fichier {action} {
global entree
global f

set w .filebox
toplevel $w
wm title $w "File selection"
wm iconname $w "filebox"

label $w.msg -wraplength 4i -justify left -text "File name ?"
pack $w.msg -side top
 
frame $w.buttons
pack $w.buttons -side bottom -fill x -pady 2m
button $w.buttons.cancel -text "Cancel" -command {set entree(ok) 0}
button $w.buttons.ok -text "OK" -command {set entree(ok) 1}
pack $w.buttons.cancel $w.buttons.ok -side left -expand 1

   set f [frame $w.$action]
if {$action == "save"} {
    set entree(result) "sans_titre.gif"
} else { 
    set entree(result) ""
}
    label $f.lab -text "$action : " -anchor e
    entry $f.ent -width 20 -textvar entree(result)
    bind $f.ent <Return> {set entree(ok) 1}
    button $f.but -text "Browse ..." -command "fileDialog $w $f.ent $action"
    pack $f.lab -side left
    pack $f.ent -side left -expand yes -fill x
    pack $f.but -side left
    pack $f -fill x -padx 1c -pady 3

    checkbutton $w.strict -text "Look Motif" \
	-variable tk_strictMotif -onvalue 1 -offvalue 0
    pack $w.strict -anchor c

if {$action == "save"} {
    set g [label $w.form_choice]
   label $g.texte -text "Save format"
   radiobutton $g.gif -variable entree(format) -value "gif" -text "gif" -command "change_fmt"
   radiobutton $g.pgm -variable entree(format) -value "pgm" -text "pgm" -command "change_fmt"
   radiobutton $g.ppm -variable entree(format) -value "ppm" -text "ppm" -command "change_fmt"
   radiobutton $g.tiff -variable entree(format) -value "tif" -text "tiff" -command "change_fmt"
   radiobutton $g.jpg -variable entree(format) -value "jpg" -text "jpg" -command "change_fmt"
   radiobutton $g.bmp -variable entree(format) -value "bmp" -text "bmp" -command "change_fmt"
   set entree(format) "gif"
   pack $g.texte -in $w.form_choice -side top
   pack $g.gif $g.pgm $g.ppm $g.tiff $g.jpg $g.bmp -in $w.form_choice -side left
   pack $g -side top
}
    
focus $f.ent
grab $w
tkwait variable entree(ok)
grab release $w
destroy $w

}

proc fileDialog {w ent operation} {
global entree

    switch $operation {
"save" {
     set types {
	 {"Image"   {.gif .pgm .ppm .tif .jpg .bmp}     }
	 {"All types"		*}
     }
 set entree(result) [tk_getSaveFile -filetypes $types -parent $w \
 -initialfile "sans_titre" -defaultextension .$entree(format) -title "sauver"]
 }
 "open" {
     set types {
	 {"Images gif"		{.gif}		}
	 {"Images pgm"		{.pgm}	        }
	 {"Images ppm"		{.ppm}		}
	 {"Images jpeg"		{.jpg .jpeg}	        }
	 {"Images tiff"		{.tif .tiff}		}
	 {"Images bmp"		{.bmp}	        }
	 {"All files"		*}
     }
set entree(result) [tk_getOpenFile -filetypes $types -parent $w \
			  -title $operation]
    }
}
}

proc nouveau {} {
global index
global entree

Select_fichier open
    if {$entree(ok)} {
incr index
NewInti $index $entree(result)
}
}

proc set_titre {image numero} {
global version

    set Imginfo [list Image [image width toto($numero)] x [image height toto($numero)]]
    set Imgnom [file tail $image]
    wm title .inti($numero) [concat Inti $version : $Imginfo - $Imgnom]
}

proc save {num} {
global entree

Select_fichier save
    if {$entree(ok)} {
     set titi toto($num)
  switch $entree(format) {
    "ppm" {$titi write $entree(result) -format PPM/PGM}
    "pgm" {coco($num) save $entree(result)}
    "gif" {$titi write $entree(result) -format GIF}
    "tif" {$titi write $entree(result) -format TIFF}
    "bmp" {$titi write $entree(result) -format BMP}
    "jpg" {$titi write $entree(result) -format JPEG}
}
}
}

proc recup {num img} {

image create photo toto($num) -file $img -palette 256/256/256
Imgnew toto($num)
update
}

proc close {num} {

destroy .inti($num)
}

proc message {text} {

toplevel .msg
wm title .msg "Message"

label .msg.corps -wraplength 4i -justify left -text $text
pack .msg.corps -side top
 
button .msg.button -text "OK" -command {set message_lu 1}
pack .msg.button -side left -expand 1
 
grab .msg
tkwait variable message_lu
grab release .msg
destroy .msg

}

proc saisie_variables {num lscale lradio} {
global parametres

set p [toplevel .param($num)]
wm title $p "Saisie de paramtres"
#set haut [expr 100 * ([llength $lscale]+[llength $lradio])]
#wm geometry $p =200x$haut
foreach var $lscale {
	set varname [lindex $var 0]
        set varmin [lindex $var 1]
	set varmax [lindex $var 2]
        if {[llength $var]>3} {
	    set resol [lindex $var 3]
	} else  {
	    set resol 1
	}
	scale $p.sc_$varname -from $varmin -to $varmax\
 	                  -label $varname \
                          -variable parametres($varname) \
	                  -resolution $resol \
                          -orient horizontal
        pack $p.sc_$varname -side top -expand 1
        }
foreach var $lradio {
    set varname [lindex $var 0]
    label $p.lab_$varname -text $varname
    frame $p.fr_$varname
    for {set i 1} {$i < [llength $var]} {incr i} {
	radiobutton $p.but_$varname$i -variable parametres($varname) \
	    -value [expr $i -1] -text [lindex $var $i]
        pack $p.but_$varname$i -in $p.fr_$varname -side left -expand 1
    }
    pack $p.lab_$varname  $p.fr_$varname -side top -expand 1
}
label $p.rampe
button $p.vazy -text "OK" -command {set parametres(fini) glop}
button $p.vazypas -text "Annuler" -command {set parametres(fini) pasglop}
pack $p.vazy $p.vazypas -in $p.rampe -side left -expand 1
pack $p.rampe -side top -expand 1
grab $p
tkwait variable parametres(fini)
grab release $p
destroy $p

}


proc magnify {num} {

global x1_zoom 
global y1_zoom
global x2_zoom 
global y2_zoom
global nx
 
set petit toto($num)
set gros bigtoto($num)
image create photo $gros -height [expr $nx($num)*($y2_zoom($num) - $y1_zoom($num))+1] \
                         -width [expr $nx($num)*($x2_zoom($num) - $x1_zoom($num))+1] \
                         -palette 256/256/256                                       
$gros copy $petit -from $x1_zoom($num) $y1_zoom($num) $x2_zoom($num) $y2_zoom($num) -zoom $nx($num)
set win .zo_$gros
if {[winfo exists $win]} {
    set titre "Zoom ($x1_zoom($num),$y1_zoom($num)) -> ($x2_zoom($num),$y2_zoom($num))"
    wm title $win $titre
} else {
toplevel $win
set titre "Zoom ($x1_zoom($num),$y1_zoom($num)) -> ($x2_zoom($num),$y2_zoom($num))"
wm title $win $titre
 
label $win.img -image $gros
pack $win.img -side top
 
button $win.button -text "Fermer" -command "image delete $gros; \
                                            destroy $win"
pack $win.button -side left -expand 1
}                                      
}

proc debutfenetre {num x y} {

global x1_zoom 
global y1_zoom
global box_anchor
global box_last

set x1_zoom($num) $x 
set y1_zoom($num) $y
catch {.inti($num).image delete $box_last($num)}
set box_anchor($num) [list $x $y]
catch {unset box_last($num)}
}

proc dessinefenetre {num x y} {
global box_anchor
global box_last
global box_tag

catch {.inti($num).image delete $box_last($num)}
set box_last($num) [eval {.inti($num).image create rect} $box_anchor($num) \
			{$x $y -tag box_tag($num) -outline red}]
}

proc finfenetre {num x y} {

global x1_zoom 
global y1_zoom
global x2_zoom 
global y2_zoom

set x2_zoom($num) [expr $x-1]
set y2_zoom($num) [expr $y-1]
set xmax [expr [image width toto($num)] - 1]
set ymax [expr [image height toto($num)] - 1]
if {$x2_zoom($num) < 1} {set x2_zoom($num) 0}
if {$y2_zoom($num) < 1} {set y2_zoom($num) 0}
if {$x2_zoom($num) > $xmax} {set x2_zoom($num) $xmax}
if {$y2_zoom($num) > $ymax} {set y2_zoom($num) $ymax}
if {($x1_zoom($num) > $x2_zoom($num))} { 
    set tp $x1_zoom($num)
    set x1_zoom($num) $x2_zoom($num)
    set x2_zoom($num) $tp
}
if {($y1_zoom($num) > $y2_zoom($num))} {
    set tp $y1_zoom($num)
    set y1_zoom($num) $y2_zoom($num)
    set y2_zoom($num) $tp
}
}

proc debutsegment {num x y} {

global x1_profil 
global y1_profil
global segment_anchor
global segment_last

if {[winfo exists .plotprof_$num]} {
    destroy .plotprof_$num
}
set x1_profil($num) $x 
set y1_profil($num) $y
set xmax [expr [image width toto($num)] - 1]
set ymax [expr [image height toto($num)] - 1]
if {$x1_profil($num) > $xmax} {set x1_profil($num) $xmax}
if {$y1_profil($num) > $ymax} {set y1_profil($num) $ymax}
if {$x1_profil($num) < 0} {set x1_profil($num) 0}
if {$y1_profil($num) < 0} {set y1_profil($num) 0}
catch {.inti($num).image delete $segment_last($num)}
set segment_anchor($num) [list $x $y]
catch {unset segment_last($num)}
}

proc dessinesegment {num x y} {
global segment_anchor
global segment_last
global segment_tag

catch {.inti($num).image delete $segment_last($num)}
set segment_last($num) [eval {.inti($num).image create line} $segment_anchor($num) {$x $y -tag segment_tag($num) -fill yellow -arrow last}]
}

proc finsegment {num x y} {

global x1_profil 
global y1_profil
global x2_profil 
global y2_profil

set x2_profil($num) $x
set y2_profil($num) $y
set xmax [expr [image width toto($num)] - 1]
set ymax [expr [image height toto($num)] - 1]
if {$x2_profil($num) > [expr $xmax-1]} {set x2_profil($num) [expr $xmax-1]}
if {$y2_profil($num) > [expr $ymax-1]} {set y2_profil($num) [expr $ymax-1]}
if {$x2_profil($num) < 1} {set x2_profil($num) 1}
if {$y2_profil($num) < 1} {set y2_profil($num) 1}
#puts "($x2_profil($num),$y2_profil($num))"
if {($x2_profil($num) != $x1_profil($num)) || \
	($y2_profil($num) != $y1_profil($num))} {
    draw_profile $num
}
}

proc draw_profile {num} {

global profil_color
global x1_profil 
global y1_profil
global x2_profil 
global y2_profil

set profil_color($num) 0
set winpr [toplevel .plotprof_$num]
wm title $winpr "Profil ($x1_profil($num),$y1_profil($num)) -> ($x2_profil($num),$y2_profil($num))"
# Calcul de la largeur de fenetre
if {[expr abs($x2_profil($num)-$x1_profil($num))]>[expr abs($y2_profil($num)-$y1_profil($num))]} {
    set largeur [expr abs($x2_profil($num)-$x1_profil($num))]
} else {
    set largeur [expr abs($y2_profil($num)-$y1_profil($num))]
}
puts "Profil : $largeur points"
canvas $winpr.cadre -bg lightgrey
canvas $winpr.body -width $largeur -height 256
pack $winpr.body -in $winpr.cadre -padx 15 -pady 15
pack $winpr.cadre -side top
$winpr.body create line 0 256 $largeur 256 -fill lightgrey -dash 3
$winpr.body create line 0 206 $largeur 206 -fill lightgrey -dash 3
$winpr.body create line 0 156 $largeur 156 -fill lightgrey -dash 3
$winpr.body create line 0 106 $largeur 106 -fill lightgrey -dash 3
$winpr.body create line 0 55 $largeur 56 -fill lightgrey -dash 3
$winpr.body create line 0 6 $largeur 6 -fill lightgrey -dash 3
$winpr.cadre create line 14 286 14 0 -fill black -arrow last
$winpr.cadre create line 0 273 [expr $largeur + 30] 273  \
    -fill black -arrow last
button $winpr.but1 -text "Fermer" -command "destroy $winpr"
button $winpr.but2 -text "Update" -command "update_profile $num"
pack $winpr.but1 $winpr.but2 -side top

update_profile $num
}


proc update_profile {num} {

global profil_color
global x1_profil 
global y1_profil
global x2_profil 
global y2_profil

set winpr .plotprof_$num
switch $profil_color($num) {
    0 {set plot_color "black"}
    1 {set plot_color "magenta"}
    2 {set plot_color "green"}
    3 {set plot_color "orange"}
    4 {set plot_color "red"}
    5 {set plot_color "blue"}
    6 {set plot_color "purple"}
    7 {set plot_color "cyan"}
    8 {set plot_color "brown"}
    9 {set plot_color "darkgrey"}
}
incr profil_color($num)
if {$profil_color($num)>9} {set profil_color($num) 0}
# calcul du quadrant
if {$x1_profil($num) < $x2_profil($num)} {set sens_x 1} else {set sens_x -1}
if {$y1_profil($num) < $y2_profil($num)} {set sens_y 1} else {set sens_y -1}
# Calcul de l'octant
set absy [expr abs($y2_profil($num)-$y1_profil($num))]
set absx [expr abs($x2_profil($num)-$x1_profil($num))]
# Initialisations diverses...
set index 1
set x_profil $x1_profil($num)  
set y_profil $y1_profil($num)
set last_val [lindex [toto($num) get $x1_profil($num) $y1_profil($num)] 0]
set indic_x [expr $sens_x*($x2_profil($num)-$x_profil)]
set indic_y [expr $sens_y*($y2_profil($num)-$y_profil)]
if {$absx > $absy} {
    set pente [expr double($y2_profil($num)-$y1_profil($num))/ \
		   double($x2_profil($num)-$x1_profil($num))]
    #puts $pente
    while {($indic_x>=0)&&($indic_y>=0)} {
	set denom [expr double($x_profil+$sens_x-$x1_profil($num))]
	set match_horiz [expr abs((double($y_profil-$y1_profil($num))/$denom)-$pente)]
	set match_both [expr abs((double($y_profil+$sens_y-$y1_profil($num))/$denom)-$pente)]
	incr x_profil $sens_x
	if {$match_both < $match_horiz} {
	    incr y_profil $sens_y
	}
	set val [lindex [toto($num) get $x_profil $y_profil] 0]
	set indic_x [expr $sens_x*($x2_profil($num)-$x_profil)]
	set indic_y [expr $sens_y*($y2_profil($num)-$y_profil)]
	$winpr.body create line $index [expr 256 -$last_val] \
	    [expr $index + 1] [expr 256 - $val] -fill $plot_color
	incr index
	set last_val $val
	#puts "($x_profil,$y_profil):$val"
    }
} else {
    set antipente [expr double($x2_profil($num)-$x1_profil($num))/ \
		       double($y2_profil($num)-$y1_profil($num))]
    #puts $antipente
    while {($indic_x>=0)&&($indic_y>=0)} {
	set denom [expr double($y_profil+$sens_y-$y1_profil($num))]
	set match_vert [expr abs((double($x_profil-$x1_profil($num))/$denom)-$antipente)]
	set match_both [expr abs((double($x_profil+$sens_x-$x1_profil($num))/$denom)-$antipente)]
	incr y_profil $sens_y
	if {$match_both < $match_vert} {
	    incr x_profil $sens_x
	}
	set val [lindex [toto($num) get $x_profil $y_profil] 0]
	set indic_x [expr $sens_x*($x2_profil($num)-$x_profil)]
	set indic_y [expr $sens_y*($y2_profil($num)-$y_profil)]
	$winpr.body create line $index [expr 256 -$last_val] \
	    [expr $index + 1] [expr 256 - $val] -fill $plot_color
	incr index
	set last_val $val
	#puts "($x_profil,$y_profil):$val"
    }
}
}


proc change_gamma {num value} {

toto($num) configure -gamma $value
}