#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tk.h>
#include "photo.hh"
#include "Image.hh"
#include "squel.hh"


/* stockage des infos d'image */

Tk_PhotoImageBlock *blockPtr;

template <class T> struct infoimage{
  Image<int> IMAGE;
  Image<int> MACROLAB;
  Image<int> microLAB;
  Image<int> DISTANCE;
  Image<int> Rel_X;
  Image<int> Rel_Y;
  Image<int> DIFFERENCE;
  Image<int> RECOMAP;
  Image<int> display;
  int* ListeLABELS;
  int flag_labels;
  int flag_distance;
  int flag_difference;
  int flag_reco;
  Tk_PhotoHandle handle;
};

/* Conversion en une image Inti avec allocation eventuelle */

Image<int> tkimage2Inti(Tk_PhotoImageBlock *tkim){
       int i,j;
       int *pixrim;
       unsigned char *pixtk;
       int tw=tkim->width;
       int th=tkim->height;
       Image<int> p(tw,th);

       pixrim=p.PI();
       for (j=0;j<tkim->height;j++) {
          pixtk=tkim->pixelPtr + tkim->pitch*j;
          for (i=0;i<tkim->width;i++) {
              int n = (int)((*(pixtk+tkim->offset[0]) + *(pixtk+tkim->offset[1]) + *(pixtk+tkim->offset[2]))/3);
              *pixrim = n;
              pixtk+=tkim->pixelSize;pixrim++;
          }
       }
       return p;
}

/* conversion en une image tk avec allocation eventuelle */

Tk_PhotoImageBlock *Inti2tkimage(Image<int>& pp,Tk_PhotoImageBlock *tkim) {
       unsigned char *tempotk;
       int *tempoplan;
       int i;
       if (tkim == NULL) {
              tkim = (Tk_PhotoImageBlock *)malloc(sizeof(Tk_PhotoImageBlock));
	      tkim->pixelPtr = NULL;
       }

       tkim->width=pp.PW();
       tkim->height=pp.PL();
       tkim->pixelSize=3;
       tkim->pitch=tkim->width*tkim->pixelSize;
       tkim->offset[0]=0;
       tkim->offset[1]=1;
       tkim->offset[2]=2;

       if (tkim->pixelPtr == NULL) {
	 tempotk= tkim->pixelPtr=(unsigned char *)malloc(tkim->pixelSize*tkim->width*tkim->height*sizeof(unsigned char));
       } else {
	 tempotk= tkim->pixelPtr=(unsigned char *)realloc(tkim->pixelPtr,tkim->pixelSize*tkim->width*tkim->height*sizeof(unsigned char));
       }
       tempoplan=pp.PI();
       for (i=0;i<tkim->width*tkim->height;i++) {
	 if (*tempoplan < 256) {
       	*tempotk = *(tempotk+tkim->offset[1]) = *(tempotk+tkim->offset[2]) = (unsigned char)(*tempoplan);
	 } else {
	   int c=(*tempoplan)-500;
	   *(tempotk+tkim->offset[0]) = 255*(c%2); 
	   *(tempotk+tkim->offset[1]) = 255*((c/2)%2);
	   *(tempotk+tkim->offset[2]) = 255*((c/4)%2);}
	tempoplan++;
	tempotk+=tkim->pixelSize;
       }
       return tkim;
}

void freetkim(Tk_PhotoImageBlock *tkim) {
       free(tkim->pixelPtr);
       free(tkim);
}



int Inti_cmd(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
       infoimage<int>* cdata;
       cdata  = (infoimage<int>*) clientData;
       
       float x,y,t1,t2;
       int a,b,c;
       char *fich;
       float x1,x2;
       
       if (strcmp(argv[1],"show-Mlab") == 0)
	 {if ((!cdata->flag_labels)||(cdata->flag_distance)) {
	   printf("Computing initial labels\n");
	   Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	   cdata->flag_labels=1;cdata->flag_distance=0;
	 }
	 Display_Mlabels(cdata->display,cdata->MACROLAB,cdata->ListeLABELS);
	 printf("Displaying initial Macro-labels\n\n");
	 } 
       else
       if (strcmp(argv[1],"show-mlab") == 0)
	 {if ((!cdata->flag_labels)||(cdata->flag_distance)) {
	   printf("Computing initial labels\n");
	   Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	   cdata->flag_labels=1;cdata->flag_distance=0;
	 }
	 Display_mlabels(cdata->display,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS,0);
	 printf("Displaying initial micro-labels\n\n");
	 }
       else
       if (strcmp(argv[1],"unroll") == 0)
	 {if ((!cdata->flag_labels)||(cdata->flag_distance)) {
	   printf("Computing initial labels\n");
	   Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	   cdata->flag_labels=1;cdata->flag_distance=0;
	 }
	 printf("Checking micro-label order\n\n");
	 Unroll_mlabels(cdata->display,cdata->microLAB,atoi(argv[2]));
	 }
       else
       if (strcmp(argv[1],"show-d0") == 0)
	 {if (!(cdata->flag_labels)||(cdata->flag_distance)) {
	   printf("Computing initial labels\n");
	   Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	   cdata->flag_labels=1;
	 }
	 if (cdata->flag_distance != 1) {
	   printf("Computing Euclidean distance transform\n");
	   Compute_distance(cdata->MACROLAB,cdata->microLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DISTANCE);
	   cdata->flag_distance=1;
	    cdata->flag_difference=0;
	     cdata->flag_reco=0;
	 }
	 printf("Displaying Euclidean distance transform\n\n");
	  Display_distance(cdata->display,cdata->DISTANCE,atoi(argv[2]));
	 }
       else
        if (strcmp(argv[1],"show-d8") == 0)
	 {if (!(cdata->flag_labels)||(cdata->flag_distance)) {
	   printf("Computing initial labels\n");
	   Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	   cdata->flag_labels=1;
	 }
	 if (cdata->flag_distance != 8) {
	   printf("Computing D8 distance transform\n");
	   Compute_d8(cdata->MACROLAB,cdata->microLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DISTANCE);
	   cdata->flag_distance=8;
	    cdata->flag_difference=0;
	    cdata->flag_reco=0;
	 }
	 printf("Displaying D8 distance transform\n\n");
	  Display_d48(cdata->display,cdata->DISTANCE,atoi(argv[2]));
	 }
       else
	if (strcmp(argv[1],"show-d4") == 0)
	 {if ((!cdata->flag_labels)||(cdata->flag_distance)) {
	   printf("Computing initial labels\n");
	   Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	   cdata->flag_labels=1;
	 }
	 if (cdata->flag_distance != 4) {
	   printf("Computing D4 distance transform\n");
	   Compute_d4(cdata->MACROLAB,cdata->microLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DISTANCE);
	   cdata->flag_distance=4;
	   cdata->flag_difference=0;
	   cdata->flag_reco=0;
	 }
	 printf("Displaying D4 distance transform\n\n");
	  Display_d48(cdata->display,cdata->DISTANCE,atoi(argv[2]));
	 }
       else
	if (strcmp(argv[1],"show-d34") == 0)
	 {if ((!cdata->flag_labels)||(cdata->flag_distance)) {
	   printf("Computing initial labels\n");
	   Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	   cdata->flag_labels=1;
	 }
	 if (cdata->flag_distance != 34) {
	   printf("Computing D3-4 distance transform\n");
	   Compute_d34(cdata->MACROLAB,cdata->microLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DISTANCE);
	   cdata->flag_distance=34;
	   cdata->flag_difference=0;
	   cdata->flag_reco=0;
	 }
	 printf("Displaying D3-4 distance transform\n\n");
	  Display_d48(cdata->display,cdata->DISTANCE,atoi(argv[2]));
	 }
	else
	if (strcmp(argv[1],"show-d5711") == 0)
	 {if ((!cdata->flag_labels)||(cdata->flag_distance)) {
	   printf("Computing initial labels\n");
	   Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	   cdata->flag_labels=1;
	 }
	 if (cdata->flag_distance != 5711) {
	   printf("Computing D5-7-11 distance transform\n");
	   Compute_d5711(cdata->MACROLAB,cdata->microLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DISTANCE);
	   cdata->flag_distance=5711;
	   cdata->flag_difference=0;
	   cdata->flag_reco=0;
	 }
	 printf("Displaying D5-7-11 distance transform\n\n");
	  Display_d48(cdata->display,cdata->DISTANCE,atoi(argv[2]));
	 }
       else
	if (strcmp(argv[1],"show-d14203144") == 0)
	 {if ((!cdata->flag_labels)||(cdata->flag_distance)) {
	   printf("Computing initial labels\n");
	   Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	   cdata->flag_labels=1;
	 }
	 if (cdata->flag_distance != 14203144) {
	   printf("Computing D14-20-31-44 distance transform\n");
	   Compute_d14203144(cdata->MACROLAB,cdata->microLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DISTANCE);
	   cdata->flag_distance=14203144;
	   cdata->flag_difference=0;
	   cdata->flag_reco=0;
	 }
	 printf("Displaying D14-20-31-44 distance transform\n\n");
	  Display_d48(cdata->display,cdata->DISTANCE,atoi(argv[2]));
	 }
       else
       if (strcmp(argv[1],"propag-Mlab") == 0)
	 {if (!cdata->flag_labels) {
	   printf("Computing initial labels\n");
	   Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	   cdata->flag_labels=1;
	 }
	 if (!cdata->flag_distance) {
	   printf("Computing Euclidean distance transform\n");
	   Compute_distance(cdata->MACROLAB,cdata->microLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DISTANCE);
	   cdata->flag_distance=1;
	 }
	 printf("Displaying propagated Macro-labels\n\n");
	 Display_Mlabels(cdata->display,cdata->MACROLAB,cdata->ListeLABELS);
	 }
       else
       if (strcmp(argv[1],"propag-mlab") == 0)
	 {if (!cdata->flag_labels) {
	   printf("Computing initial labels\n");
	   Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	   cdata->flag_labels=1;
	 }
	 if (!cdata->flag_distance) {
	   printf("Computing Euclidean distance transform\n");
	   Compute_distance(cdata->MACROLAB,cdata->microLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DISTANCE);
	   cdata->flag_distance=1;
	 }
	 printf("Displaying propagated micro-labels\n\n");
	 Display_mlabels(cdata->display,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS,atoi(argv[2]));
	 }
       else
       if (strcmp(argv[1],"show-diff1") == 0)
	 {if (!cdata->flag_labels) {
	   printf("Computing initial labels\n");
	   Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	   cdata->flag_labels=1;
	 }
	 if (!cdata->flag_distance) {
	   printf("Computing Euclidean distance transform\n");
	   Compute_distance(cdata->MACROLAB,cdata->microLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DISTANCE);
	   cdata->flag_distance=1;
	 }
	 if (cdata->flag_difference!=1) {
	   printf("Computing Geodesic distance Shock function\n");
	   Compute_difference(cdata->MACROLAB,cdata->microLAB,cdata->DIFFERENCE,cdata->ListeLABELS);
	   cdata->flag_difference=1;
	   cdata->flag_reco=0;
	 }
	 printf("Displaying Geodesic distance Shock function\n");
	 Display_difference(cdata->display,cdata->DIFFERENCE);
	 }
        else
       if (strcmp(argv[1],"show-diff2") == 0)
	 {if (!cdata->flag_labels) {
	   printf("Computing initial labels\n");
	   Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	   cdata->flag_labels=1;
	 }
	 if (!cdata->flag_distance) {
	   printf("Computing Euclidean distance transform\n");
	   Compute_distance(cdata->MACROLAB,cdata->microLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DISTANCE);
	   cdata->flag_distance=1;
	 }
	 if (cdata->flag_difference!=2) {
	   printf("Computing L1 distance Shock function\n");
	   Compute_diff2(cdata->MACROLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DIFFERENCE);
	   cdata->flag_difference=2;
	   cdata->flag_reco=0;
	 }
	 printf("Displaying L1 distance Shock function\n");
	 Display_difference(cdata->display,cdata->DIFFERENCE);
	 }
        else
       if (strcmp(argv[1],"show-diff3") == 0)
	 {if (!cdata->flag_labels) {
	   printf("Computing initial labels\n");
	   Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	   cdata->flag_labels=1;
	 }
	 if (!cdata->flag_distance) {
	   printf("Computing Euclidean distance transform\n");
	   Compute_distance(cdata->MACROLAB,cdata->microLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DISTANCE);
	   cdata->flag_distance=1;
	 }
	 if (cdata->flag_difference!=3) {
	   printf("Computing Angle Shock function\n");
	   Compute_diff3(cdata->MACROLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DIFFERENCE);
	   cdata->flag_difference=3;
	   cdata->flag_reco=0;
	 }
	 printf("Displaying Angle Shock function\n");
	 Display_difference(cdata->display,cdata->DIFFERENCE);
	 }
       else
       if (strcmp(argv[1],"show-diff4") == 0)
	 {if (!cdata->flag_labels) {
	   printf("Computing initial labels\n");
	   Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	   cdata->flag_labels=1;
	 }
	 if (!cdata->flag_distance) {
	   printf("Computing Euclidean distance transform\n");
	   Compute_distance(cdata->MACROLAB,cdata->microLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DISTANCE);
	   cdata->flag_distance=1;
	 }
	 if (cdata->flag_difference!=4) {
	   printf("Computing (Angle x Distance) Shock function\n");
	   Compute_diff4(cdata->MACROLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DIFFERENCE);
	   cdata->flag_difference=4;
	   cdata->flag_reco=0;
	 }
	 printf("Displaying (Angle x Distance) Shock function\n");
	 Display_difference(cdata->display,cdata->DIFFERENCE);
	 }
       else
        if (strcmp(argv[1],"show-skel") == 0)
	 {if (!cdata->flag_labels) {
	   printf("Computing initial labels\n");
	   Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	   cdata->flag_labels=1;
	 }
	 if (!cdata->flag_distance) {
	   printf("Computing Euclidean distance transform\n");
	   Compute_distance(cdata->MACROLAB,cdata->microLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DISTANCE);
	   cdata->flag_distance=1;
	 }
	 if (!cdata->flag_difference) {
	   printf("Computing Geodesic distance Shock function\n");
	   Compute_difference(cdata->MACROLAB,cdata->microLAB,cdata->DIFFERENCE,cdata->ListeLABELS);
	   cdata->flag_difference=1;
	 }
	 Compute_Skeleton(cdata->display,cdata->DIFFERENCE,cdata->IMAGE,atoi(argv[2]));
	 }
       	else
	if (strcmp(argv[1],"show-reco-map") == 0)
	  {if (!cdata->flag_labels) {
	    printf("Computing initial labels\n");
	    Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	    cdata->flag_labels=1;
	 }
	 if (!cdata->flag_distance) {
	   printf("Computing Euclidean distance transform\n");
	   Compute_distance(cdata->MACROLAB,cdata->microLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DISTANCE);
	   cdata->flag_distance=1;
	 }
	 if (!cdata->flag_difference) {
	   printf("Computing Geodesic distance Shock function\n");
	   Compute_difference(cdata->MACROLAB,cdata->microLAB,cdata->DIFFERENCE,cdata->ListeLABELS);
	   cdata->flag_difference=1;
	 }
	 if (!cdata->flag_reco) {
	   printf("Computing reconstruction map\n");
	 Compute_reconstruction_map(cdata->RECOMAP,cdata->IMAGE,cdata->DIFFERENCE,cdata->DISTANCE,cdata->flag_distance);
	 cdata->flag_reco=1;
	  }
	 printf("Displaying reconstruction map\n\n");
	 Display_reco(cdata->display,cdata->RECOMAP,atoi(argv[2]));
	  }
	else
	if (strcmp(argv[1],"show-reco") == 0)
	  {if (!cdata->flag_labels) {
	    printf("Computing initial labels\n");
	    Compute_labels(cdata->IMAGE,cdata->MACROLAB,cdata->microLAB,cdata->ListeLABELS);
	    cdata->flag_labels=1;
	 }
	 if (!cdata->flag_distance) {
	   printf("Computing Euclidean distance transform\n");
	   Compute_distance(cdata->MACROLAB,cdata->microLAB,cdata->Rel_X,cdata->Rel_Y,cdata->DISTANCE);
	   cdata->flag_distance=1;
	 }
	 if (!cdata->flag_difference) {
	   printf("Computing Geodesic distance Shock function\n");
	   Compute_difference(cdata->MACROLAB,cdata->microLAB,cdata->DIFFERENCE,cdata->ListeLABELS);
	   cdata->flag_difference=1;
	 }
	 if (!cdata->flag_reco) {
	   printf("Computing reconstruction map\n");
	 Compute_reconstruction_map(cdata->RECOMAP,cdata->IMAGE,cdata->DIFFERENCE,cdata->DISTANCE,cdata->flag_distance);
	 cdata->flag_reco=1;
	  }
	 Compute_reconstruction(cdata->display,cdata->RECOMAP,atoi(argv[2]));
	  }
       else
       if (strcmp(argv[1],"show-img") == 0)
	 {cdata->display=cdata->IMAGE;printf("Displaying original image\n");}
       blockPtr=Inti2tkimage(cdata->display,blockPtr);
       Tk_PhotoPutBlock(cdata->handle, blockPtr, 0, 0, blockPtr->width, blockPtr->height);
       return TCL_OK;       
}

int img_new(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
       infoimage<int> *cdata;
       Tk_PhotoImageBlock blockPtr;
       cdata = (infoimage<int>*) clientData;
       char *error_msg;

     if (argc != 2) {
                sprintf(error_msg,"Usage: Imgnew <image>");
                Tcl_SetResult(interp,error_msg,TCL_VOLATILE);
		return TCL_ERROR;
	}
   cdata->handle=Tk_FindPhoto(interp,argv[1]);
   Tk_PhotoGetImage(cdata->handle, &blockPtr);
   cdata->display=tkimage2Inti(&blockPtr);
   cdata->IMAGE=tkimage2Inti(&blockPtr);
   cdata->IMAGE=cdata->display;
   cdata->MACROLAB=tkimage2Inti(&blockPtr);
   cdata->microLAB=tkimage2Inti(&blockPtr);
   cdata->DISTANCE=tkimage2Inti(&blockPtr);
   cdata->Rel_X=tkimage2Inti(&blockPtr);
   cdata->Rel_Y=tkimage2Inti(&blockPtr);
   cdata->DIFFERENCE=tkimage2Inti(&blockPtr);
   cdata->RECOMAP=tkimage2Inti(&blockPtr);
   cdata->ListeLABELS = (int *)calloc(250,sizeof(int));
   cdata->flag_labels = 0;
   cdata->flag_distance = 0;
   cdata->flag_difference = 0;
   cdata->flag_reco = 0;
 return TCL_OK;
}


/* creation d'une image de type Inti */
/* Intinew <nomimage> <nomcommanderet> */

void init_retcc() {
blockPtr = NULL;
}

int Inti_new(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
       infoimage<int> *cdata;
       char *error_msg;

	if (argc != 2) {
           sprintf(error_msg,"Usage: Intinew <nomcommande>");
           Tcl_SetResult(interp,error_msg,TCL_VOLATILE);
	   return TCL_ERROR;
	}
         cdata = new infoimage<int>;
         Tcl_CreateCommand(interp, "Imgnew", img_new, (ClientData)cdata,(Tcl_CmdDeleteProc *)NULL);
         Tcl_CreateCommand(interp, argv[1], Inti_cmd, (ClientData)cdata,(Tcl_CmdDeleteProc *)NULL);
         return TCL_OK;
}


