#include "Image.hh"
#include "squel.hh"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>


#define MAX(x,y) ((x) > (y) ? (x) : (y))
#define MIN(x,y) ((x) < (y) ? (x) : (y))

#define MAX4(x,y,z,w) \
	((MAX((x),(y))) > (MAX((z),(w))) ? (MAX((x),(y))) : (MAX((z),(w))))
#define MIN4(x,y,z,w) \
	((MIN((x),(y))) < (MIN((z),(w))) ? (MIN((x),(y))) : (MIN((z),(w))))

void Compute_labels(Image<int>& p_original,Image<int>& p_macrolab,Image<int>& p_microlab,int* ListeLABELS) { 
  
   int h=p_original.PL();
   int w=p_original.PW();
   int i,j,x,y,a,b;
   int nb_labels = 0;
   int indice,dir,debut,dir_prec;
   int match,fini,index;
   int first_x,first_y;
   int second_x,second_y;
   int* MACROLAB=p_macrolab.PI();
   int* microLAB=p_microlab.PI();
   
   // Initialisation labels...
   index=0;
   for (j=0;j<h;j++)
     for (i=0;i<w;i++) {
       if (p_original.X(i,j)&&!(p_original.X(i-1,j)&&p_original.X(i,j-1)&&p_original.X(i+1,j)&&p_original.X(i,j+1))) {
	 MACROLAB[index]=1000; 
       } else {
	 MACROLAB[index]=0;
	 microLAB[index]=0;
       }
       index++;
     }
for (j=0;j<h;j++)
     for (i=0;i<w;i++) {
       if ((p_macrolab.X(i,j)==1000)&&(!p_original.X(i-1,j))) {
         indice = 1;
         MACROLAB[j*w+i] = ++nb_labels;
         microLAB[j*w+i] = 1;
	 if (!(p_original.X(i-1,j-1)||p_original.X(i-1,j)||
	       p_original.X(i-1,j+1)||p_original.X(i,j-1)||
	       p_original.X(i,j+1)||p_original.X(i+1,j-1)||
	       p_original.X(i+1,j)||p_original.X(i+1,j+1))) 
	     fini = 1;
	     else {
	       first_x = i;first_y = j;
	       x = i; y = j; fini = 0;
	       debut = 1; dir = 4;
	       a = 0;b = 0;
	     }
         while (!fini) {
	   match = 0;
	   while (!match) {
	     dir = (dir+1)%8;
             switch (dir) {
             case 0 : {a=x+1;b=y;dir_prec=6;break;}
             case 1 : {a=x+1;b=y-1;dir_prec=6;break;}
             case 2 : {a=x;b=y-1;dir_prec=0;break;}
             case 3 : {a=x-1;b=y-1;dir_prec=0;break;}
             case 4 : {a=x-1;b=y;dir_prec=2;break;}
             case 5 : {a=x-1;b=y+1;dir_prec=2;break;}
             case 6 : {a=x;b=y+1;dir_prec=4;break;}
             case 7 : {a=x+1;b=y+1;dir_prec=4;break;}
	     }
             if (p_original.X(a,b)&&(a>=0)&&(b>=0)&&(a<w)&&(b<h)) {
	       match = 1;
	       if (debut) {
		 second_x = a;second_y = b;debut = 0;
	       }
	       else {
		 if ((x==first_x)&&(y==first_y)&&(a==second_x)&&(b==second_y)) 
		   fini=1;}
	       if (!fini) {
		 if (p_macrolab.X(a,b)==1000) {
		   MACROLAB[b*w+a]= nb_labels;
		   //if (dir%2) indice = indice+7; else indice=indice+5;
		   microLAB[b*w+a] = ++indice;
		 }
		 x = a;y = b;
		 switch (dir_prec) {
		 case 0 : {a=a+1;break;}
		 case 2 : {b=b-1;break;}
		 case 4 : {a=a-1;break;}
		 case 6 : {b=b+1;break;}
		 }
		 dir = dir_prec;
	       }
	     }
	   }
	 }
	 ListeLABELS[nb_labels]=indice;
	 printf("contour n%d : %d points\n",nb_labels,indice);
       }
     }
   // Nombre de labels
 ListeLABELS[0] = nb_labels; 
 printf("%d labels\n",ListeLABELS[0]);
}


void Compute_labels_alternate(Image<int>& p_original,Image<int>& p_macrolab,Image<int>& p_microlab,int* ListeLABELS) { 
  
   int h=p_original.PL();
   int w=p_original.PW();
   int i,j,x,y,a,b;
   int nb_labels = 0;
   int indice,match,index,dir;
   FIFO f(w*h);
   int* MACROLAB=p_macrolab.PI();
   int* microLAB=p_microlab.PI();
   
   // Initialisation labels...
   for (j=0;j<h;j++)
     for (i=0;i<w;i++) 
       if (p_original.X(i,j)&&!(p_original.X(i-1,j)&&p_original.X(i,j-1)&&p_original.X(i+1,j)&&p_original.X(i,j+1))) {
	 MACROLAB[j*w+i]=1000; 
       } else {
	 MACROLAB[j*w+i]=0;
	 microLAB[j*w+i]=0;
       }
   for (j=0;j<h;j++)
     for (i=0;i<w;i++) {
       if (MACROLAB[j*w+i] == 1000) {
	 indice = 1;
	 match = 0;
	 MACROLAB[j*w+i] = ++nb_labels;
	 microLAB[j*w+i] = 1;
	 // Amorce du contour
	 for (dir=0;dir<4;dir++) {
	   switch (dir) {
	   case 0 : {a=1;b=0;break;}
	   case 1 : {a=1;b=1;break;}
	   case 2 : {a=0;b=1;break;}
	   case 3 : {a=-1;b=1;break;}
	   }
	   if ((p_macrolab.X(i+a,j+b)==1000)&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	     if (!match) {f.FIFO_add(i+a,j+b);match = 1;}
	     MACROLAB[(j+b)*w+i+a]= nb_labels;
	     microLAB[(j+b)*w+i+a] = ++indice;
	   }
	 }
	 // Suivi du contour
	 while (!f.FIFO_empty()) {
	   f.FIFO_get(x,y);
	   for (int a=-1;a<=1;a++)
	     for (int b=-1;b<=1;b++) {
	       if ((a!=0)||(b!=0)) {
		 if ((p_macrolab.X(x+a,y+b)==1000)&&(x+a>=0)&&(y+b>=0)&&(x+a<w)&&(y+b<h)) {
		   f.FIFO_add(x+a,y+b);
		   MACROLAB[(y+b)*w+x+a]= nb_labels;
		   microLAB[(y+b)*w+x+a] = ++indice;
		 }
	       }
	     }
	 }
	 ListeLABELS[nb_labels]=indice;
	 printf("contour n%d : %d points\n",nb_labels,indice);
       }
     }
   // Nombre de labels
   ListeLABELS[0] = nb_labels; 
   printf("%d labels\n",ListeLABELS[0]);
}


void Display_mlabels(Image<int>& p_display,Image<int>& p_macrolab,Image<int>& p_microlab,int* ListeLABELS,int pref_color) {
  
  int i,j,index;
  int h=p_display.PL();
  int w=p_display.PW();
  int* PIX=p_display.PI();
  int* MACROLAB=p_macrolab.PI();
  int* microLAB=p_microlab.PI();
  
  index = 0;
  if (!pref_color) {
    for (j=0;j<h;j++)
      for (i=0;i<w;i++) {
	if (MACROLAB[index]) PIX[index] = (microLAB[index]*255)/ListeLABELS[MACROLAB[index]];
	else PIX[index] = 506;
	index++;
      } 
  } else {
    for (j=0;j<h;j++)
      for (i=0;i<w;i++) {
	PIX[index] = (microLAB[index]*255);
	index++;
      } 
  }
}
  
void Display_Mlabels(Image<int>& p_display,Image<int>& p_macrolab,int* ListeLABELS) {
  
  int i,j,index;
  int h=p_display.PL();
  int w=p_display.PW();
  int* PIX=p_display.PI();
  int* MACROLAB=p_macrolab.PI();

  index = 0;
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      if (MACROLAB[index]) PIX[index] = (MACROLAB[index]*255)/ListeLABELS[0];
      else PIX[index] = 506;
      index++;
    }
}

// Algorithme de Shih et Wu en 2 passes
// Donne un rsultat faux 
void Compute_distance_v1(Image<int>& p_macrolab,Image<int>& p_microlab,Image<int>& p_Rx,Image<int>& p_Ry,Image<int>& p_sdet) { 
  
   int h=p_macrolab.PL();
   int w=p_macrolab.PW();
   Image<int> p_contours(p_macrolab);
   int i,j,index,dir,a,b,sedt;
   int* CONTOURS=p_contours.PI();
   int* MACROLAB=p_macrolab.PI();
   int* microLAB=p_microlab.PI();
   // f : distance carre au pixel le + proche
   int* f=p_sdet.PI();
   // R : coordonnes relatives horiz/vert du pixel le + proche
   int* RX=p_Rx.PI();
   int* RY=p_Ry.PI();

   // Balayage direct
   index = 0;
   for (j=0;j<h;j++)
     for (i=0;i<w;i++) {
       RX[index]=0;
       RY[index]=0;
       if (CONTOURS[index]) { 
	 f[index]=0;
       } else {
	 f[index]=1000000;
	 for (dir=0;dir<4;dir++) {
	   switch (dir) {
	   case 0 : {
	     a=-1;b=0;
	     sedt = p_sdet.X(i+a,j+b)+2*abs(p_Rx.X(i+a,j+b))+1;
	     break;}
	   case 1 : {
	     a=-1;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+2*(abs(p_Rx.X(i+a,j+b))+abs(p_Ry.X(i+a,j+b))+1);
	     break;}
	   case 2 : {
	     a=0;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+2*abs(p_Ry.X(i+a,j+b))+1;
	     break;}
	   case 3 : {
	     a=1;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+2*(abs(p_Rx.X(i+a,j+b))+abs(p_Ry.X(i+a,j+b))+1);
	     break;}
	   }
	   if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	     f[index] = sedt;
	     RX[index] = p_Rx.X(i+a,j+b)+a;
	     RY[index] = p_Ry.X(i+a,j+b)+b;
	     MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	     microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	     }
	 }
       }
       index++;
     }
   // Balayage retrograde
   for (j=h-1;j>=0;j--)
     for (i=w-1;i>=0;i--) {
       index--;
       for (dir=0;dir<4;dir++) {
	 switch (dir) {
	 case 0 : {
	   a=1;b=0;
	   sedt = p_sdet.X(i+a,j+b)+2*abs(p_Rx.X(i+a,j+b))+1;
	   break;}
	 case 1 : {
	   a=1;b=1;
	   sedt = p_sdet.X(i+a,j+b)+2*(abs(p_Rx.X(i+a,j+b))+abs(p_Ry.X(i+a,j+b))+1);
	   break;}
	 case 2 : {
	   a=0;b=1;
	   sedt = p_sdet.X(i+a,j+b)+2*abs(p_Ry.X(i+a,j+b))+1;
	   break;}
	 case 3 : {
	   a=-1;b=1;
	   sedt = p_sdet.X(i+a,j+b)+2*(abs(p_Rx.X(i+a,j+b))+abs(p_Ry.X(i+a,j+b))+1);
	   break;}
	 }
	 if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	   f[index] = sedt;
	   RX[index] = p_Rx.X(i+a,j+b)+a;
	   RY[index] = p_Ry.X(i+a,j+b)+b;
	   MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	   microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	 }
       }
     }

   // Debug (affichage)
   index = 0;
   for (j=0;j<h;j++) {
     for (i=0;i<w;i++) {
       printf("%03d ",f[index++]);
     }
     printf("\n");
   }

}

// Application de l'algo de Shih et Wu en 2x2 passes
// (Sur l'image et sur sa transpose) 
// N'est pas quivalent  l'algorithme de Leymarie
void Compute_distance(Image<int>& p_macrolab,Image<int>& p_microlab,Image<int>& p_Rx,Image<int>& p_Ry,Image<int>& p_sdet) { 
  
   int h=p_macrolab.PL();
   int w=p_macrolab.PW();
   Image<int> p_contours(p_macrolab);
   int i,j,index,dir,a,b,sedt;
   int* CONTOURS=p_contours.PI();
   int* MACROLAB=p_macrolab.PI();
   int* microLAB=p_microlab.PI();
   // f : distance carre au pixel le + proche
   int* f=p_sdet.PI();
   // R : coordonnes relatives horiz/vert du pixel le + proche
   int* RX=p_Rx.PI();
   int* RY=p_Ry.PI();

   // Balayage direct
   index = 0;
   for (j=0;j<h;j++)
     for (i=0;i<w;i++) {
       RX[index]=0;
       RY[index]=0;
       if (CONTOURS[index]) { 
	 f[index]=0;
       } else {
	 f[index]=1000000;
	 for (dir=0;dir<4;dir++) {
	   switch (dir) {
	   case 0 : {
	     a=-1;b=0;
	     sedt = p_sdet.X(i+a,j+b)+2*abs(p_Rx.X(i+a,j+b))+1;
	     break;}
	   case 1 : {
	     a=-1;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+2*(abs(p_Rx.X(i+a,j+b))+abs(p_Ry.X(i+a,j+b))+1);
	     break;}
	   case 2 : {
	     a=0;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+2*abs(p_Ry.X(i+a,j+b))+1;
	     break;}
	   case 3 : {
	     a=1;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+2*(abs(p_Rx.X(i+a,j+b))+abs(p_Ry.X(i+a,j+b))+1);
	     break;}
	   }
	   if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	     f[index] = sedt;
	     RX[index] = p_Rx.X(i+a,j+b)+a;
	     RY[index] = p_Ry.X(i+a,j+b)+b;
	     MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	     microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	     }
	 }
       }
       index++;
     }
   // Balayage retrograde
    for (j=h-1;j>=0;j--)
     for (i=w-1;i>=0;i--) {
       index--;
       for (dir=0;dir<4;dir++) {
	 switch (dir) {
	 case 0 : {
	   a=1;b=0;
	   sedt = p_sdet.X(i+a,j+b)+2*abs(p_Rx.X(i+a,j+b))+1;
	   break;}
	 case 1 : {
	   a=1;b=1;
	   sedt = p_sdet.X(i+a,j+b)+2*(abs(p_Rx.X(i+a,j+b))+abs(p_Ry.X(i+a,j+b))+1);
	   break;}
	 case 2 : {
	   a=0;b=1;
	   sedt = p_sdet.X(i+a,j+b)+2*abs(p_Ry.X(i+a,j+b))+1;
	   break;}
	 case 3 : {
	   a=-1;b=1;
	   sedt = p_sdet.X(i+a,j+b)+2*(abs(p_Rx.X(i+a,j+b))+abs(p_Ry.X(i+a,j+b))+1);
	   break;}
	 }
	 if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	   f[index] = sedt;
	   RX[index] = p_Rx.X(i+a,j+b)+a;
	   RY[index] = p_Ry.X(i+a,j+b)+b;
	   MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	   microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	 }
       }
     }
   //   Balayage de gauche  droite
     for (i=0;i<w;i++) 
       for (j=0;j<h;j++) {
       index = j*w+i;
       for (dir=0;dir<4;dir++) {
	 switch (dir) {
	 case 0 : {
	   a=-1;b=0;
	   sedt = p_sdet.X(i+a,j+b)+2*abs(p_Rx.X(i+a,j+b))+1;
	   break;}
	 case 1 : {
	   a=-1;b=-1;
	   sedt = p_sdet.X(i+a,j+b)+2*(abs(p_Rx.X(i+a,j+b))+abs(p_Ry.X(i+a,j+b))+1);
	   break;}
	 case 2 : {
	   a=0;b=-1;
	   sedt = p_sdet.X(i+a,j+b)+2*abs(p_Ry.X(i+a,j+b))+1;
	   break;}
	 case 3 : {
	   a=-1;b=1;
	   sedt = p_sdet.X(i+a,j+b)+2*(abs(p_Rx.X(i+a,j+b))+abs(p_Ry.X(i+a,j+b))+1);
	   break;}
	 }
	 if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	   f[index] = sedt;
	   RX[index] = p_Rx.X(i+a,j+b)+a;
	   RY[index] = p_Ry.X(i+a,j+b)+b;
	   MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	   microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	 }
       }
     }
     // Balayage de droite  gauche
     for (i=w-1;i>=0;i--) 
       for (j=h-1;j>=0;j--) {
       index = j*w+i;
       for (dir=0;dir<4;dir++) {
	 switch (dir) {
	 case 0 : {
	   a=1;b=0;
	   sedt = p_sdet.X(i+a,j+b)+2*abs(p_Rx.X(i+a,j+b))+1;
	   break;}
	 case 1 : {
	   a=1;b=1;
	   sedt = p_sdet.X(i+a,j+b)+2*(abs(p_Rx.X(i+a,j+b))+abs(p_Ry.X(i+a,j+b))+1);
	   break;}
	 case 2 : {
	   a=0;b=1;
	   sedt = p_sdet.X(i+a,j+b)+2*abs(p_Ry.X(i+a,j+b))+1;
	   break;}
	 case 3 : {
	   a=1;b=-1;
	   sedt = p_sdet.X(i+a,j+b)+2*(abs(p_Rx.X(i+a,j+b))+abs(p_Ry.X(i+a,j+b))+1);
	   break;}
	 }
	 if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	   f[index] = sedt;
	   RX[index] = p_Rx.X(i+a,j+b)+a;
	   RY[index] = p_Ry.X(i+a,j+b)+b;
	   MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	   microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	 }
       }
     }
      // Debug (affichage)
   // index = 0;
//    for (j=0;j<h;j++) {
//      for (i=0;i<w;i++) {
//        printf("%03d ",f[index++]);
//      }
//      printf("\n");
//    }
 }

// Algorithme de Leymarie en 4 scans
void Compute_distance_v3(Image<int>& p_macrolab,Image<int>& p_microlab,Image<int>& p_Rx,Image<int>& p_Ry,Image<int>& p_sdet) { 
  
   int h=p_macrolab.PL();
   int w=p_macrolab.PW();
   Image<int> p_contours(p_macrolab);
   int i,j,index,dir,a,b,sedt,indexbis;
   int* CONTOURS=p_contours.PI();
   int* MACROLAB=p_macrolab.PI();
   int* microLAB=p_microlab.PI();
   // f : distance carre au pixel le + proche
   int* f=p_sdet.PI();
   // R : coordonnes relatives horiz/vert du pixel le + proche
   int* RX=p_Rx.PI();
   int* RY=p_Ry.PI();

   // Initialisation
   index = 0;
   for (j=0;j<h;j++) 
     for (i=0;i<w;i++) {
       RX[index]=0;
       RY[index]=0;
       if (CONTOURS[index])
	 f[index]=0;
       else
	 f[index]=1000000;
       index++;
     }

   // Balayage direct
   index = 0;
   indexbis = w;
   for (j=0;j<h;j++) {
     for (i=0;i<w;i++) {
       for (dir=0;dir<4;dir++) {
	 switch (dir) {
	 case 0 : {
	   a=-1;b=0;
	   sedt = p_sdet.X(i+a,j+b)+2*abs(p_Rx.X(i+a,j+b))+1;
	   break;}
	 case 1 : {
	   a=-1;b=-1;
	   sedt = p_sdet.X(i+a,j+b)+2*(abs(p_Rx.X(i+a,j+b))+abs(p_Ry.X(i+a,j+b))+1);
	   break;}
	 case 2 : {
	   a=0;b=-1;
	   sedt = p_sdet.X(i+a,j+b)+2*abs(p_Ry.X(i+a,j+b))+1;
	   break;}
	 case 3 : {
	   a=1;b=-1;
	   sedt = p_sdet.X(i+a,j+b)+2*(abs(p_Rx.X(i+a,j+b))+abs(p_Ry.X(i+a,j+b))+1);
	   break;}
	 }
	 if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	   f[index] = sedt;
	   RX[index] = p_Rx.X(i+a,j+b)+a;
	   RY[index] = p_Ry.X(i+a,j+b)+b;
	   MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	   microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	 }
       }
       index++;
       // 2e masque direct, pass de droite  gauche
       indexbis--;
       a=1;b=0;
       sedt = p_sdet.X(w-1-i+a,j+b)+2*abs(p_Rx.X(w-1-i+a,j+b))+1;
       if ((sedt<f[indexbis])&&(w-1-i+a>=0)&&(j+b>=0)&&(w-1-i+a<w)&&(j+b<h)) {
	 f[indexbis] = sedt;
	 RX[indexbis] = p_Rx.X(w-1-i+a,j+b)+a;
	 RY[indexbis] = p_Ry.X(w-1-i+a,j+b)+b;
	 MACROLAB[indexbis]=p_macrolab.X(w-1-i+RX[indexbis],j+RY[indexbis]);
	 microLAB[indexbis]=p_microlab.X(w-1-i+RX[indexbis],j+RY[indexbis]);
       }
     }
     indexbis += 2*w;
   }
   // Balayage retrograde
   for (j=h-1;j>=0;j--) { 
     indexbis -= 2*w;
     for (i=w-1;i>=0;i--) {
       index--;
       for (dir=0;dir<4;dir++) {
	 switch (dir) {
	 case 0 : {
	   a=1;b=0;
	   sedt = p_sdet.X(i+a,j+b)+2*abs(p_Rx.X(i+a,j+b))+1;
	   break;}
	 case 1 : {
	   a=1;b=1;
	   sedt = p_sdet.X(i+a,j+b)+2*(abs(p_Rx.X(i+a,j+b))+abs(p_Ry.X(i+a,j+b))+1);
	   break;}
	 case 2 : {
	   a=0;b=1;
	   sedt = p_sdet.X(i+a,j+b)+2*abs(p_Ry.X(i+a,j+b))+1;
	   break;}
	 case 3 : {
	   a=-1;b=1;
	   sedt = p_sdet.X(i+a,j+b)+2*(abs(p_Rx.X(i+a,j+b))+abs(p_Ry.X(i+a,j+b))+1);
	   break;}
	 }
	 if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	   f[index] = sedt;
	   RX[index] = p_Rx.X(i+a,j+b)+a;
	   RY[index] = p_Ry.X(i+a,j+b)+b;
	   MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	   microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	 }
       }
       // 2e masque retrograde, pass de gauche  droite
       a=-1;b=0;
       sedt = p_sdet.X(w-1-i+a,j+b)+2*abs(p_Rx.X(w-1-i+a,j+b))+1;
       if ((sedt<f[indexbis])&&(w-1-i+a>=0)&&(j+b>=0)&&(w-1-i+a<w)&&(j+b<h)) {
	 f[indexbis] = sedt;
	 RX[indexbis] = p_Rx.X(w-1-i+a,j+b)+a;
	 RY[indexbis] = p_Ry.X(w-1-i+a,j+b)+b;
	 MACROLAB[indexbis]=p_macrolab.X(w-1-i+RX[indexbis],j+RY[indexbis]);
	 microLAB[indexbis]=p_microlab.X(w-1-i+RX[indexbis],j+RY[indexbis]);
       }
       indexbis++;
     }
   }
    // Debug (affichage)
   // index = 0;
//    for (j=0;j<h;j++) {
//      for (i=0;i<w;i++) {
//        printf("%03d ",f[index++]);
//      }
//      printf("\n");
//    }
}

void Display_distance(Image<int>& p_display,Image<int>& p_sdet,int pref_color) {
  
  int i,j,index,valmax;
  int h=p_display.PL();
  int w=p_display.PW();
  int* PIX=p_display.PI();
  int* f=p_sdet.PI();
  
  index = 0;
  valmax = 0;
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      PIX[index] = (int)sqrt((double)f[index]);
      if (PIX[index]>valmax) valmax=PIX[index];
      index++;
    }
  if (pref_color) valmax = 1;
  index = 0;
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      PIX[index]=(PIX[index]*255)/valmax;
      index++;
    }
}

void Compute_d8(Image<int>& p_macrolab,Image<int>& p_microlab,Image<int>& p_Rx,Image<int>& p_Ry,Image<int>& p_sdet) { 
  
   int h=p_macrolab.PL();
   int w=p_macrolab.PW();
   Image<int> p_contours(p_macrolab);
   int i,j,index,dir,a,b,sedt;
   int* CONTOURS=p_contours.PI();
   int* MACROLAB=p_macrolab.PI();
   int* microLAB=p_microlab.PI();
   // f : distance au pixel le + proche
   int* f=p_sdet.PI();
 // R : coordonnes relatives horiz/vert du pixel le + proche
   int* RX=p_Rx.PI();
   int* RY=p_Ry.PI();

   // Balayage direct
   index = 0;
   for (j=0;j<h;j++)
     for (i=0;i<w;i++) {
       RX[index]=0;
       RY[index]=0;
       if (CONTOURS[index]) { 
	 f[index]=0;
       } else {
	 f[index]=1000000;
	 for (dir=0;dir<4;dir++) {
	   switch (dir) {
	   case 0 : {
	     a=-1;b=0;
	     break;}
	   case 1 : {
	     a=-1;b=-1;
	     break;}
	   case 2 : {
	     a=0;b=-1;
	     break;}
	   case 3 : {
	     a=1;b=-1;
	     break;}
	   }
	   sedt = p_sdet.X(i+a,j+b)+1;
	   if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	     f[index] = sedt;
	     RX[index] = p_Rx.X(i+a,j+b)+a;
	     RY[index] = p_Ry.X(i+a,j+b)+b;
	     MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	     microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	     }
	 }
       }
       index++;
     }
   // Balayage retrograde
   for (j=h-1;j>=0;j--)
     for (i=w-1;i>=0;i--) {
       index--;
       for (dir=0;dir<4;dir++) {
	 switch (dir) {
	 case 0 : {
	   a=1;b=0;
	   break;}
	 case 1 : {
	   a=1;b=1;
	   break;}
	 case 2 : {
	   a=0;b=1;
	   break;}
	 case 3 : {
	   a=-1;b=1;
	   break;}
	 }
	 sedt = p_sdet.X(i+a,j+b)+1;
	 if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	   f[index] = sedt;
	   RX[index] = p_Rx.X(i+a,j+b)+a;
	   RY[index] = p_Ry.X(i+a,j+b)+b;
	   MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	   microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	 }
       }
     }
 }

void Compute_d4(Image<int>& p_macrolab,Image<int>& p_microlab,Image<int>& p_Rx,Image<int>& p_Ry,Image<int>& p_sdet) { 
  
   int h=p_macrolab.PL();
   int w=p_macrolab.PW();
   Image<int> p_contours(p_macrolab);
   int i,j,index,dir,a,b,sedt;
   int* CONTOURS=p_contours.PI();
   int* MACROLAB=p_macrolab.PI();
   int* microLAB=p_microlab.PI();
   // f : distance au pixel le + proche
   int* f=p_sdet.PI();
   // R : coordonnes relatives horiz/vert du pixel le + proche
   int* RX=p_Rx.PI();
   int* RY=p_Ry.PI();

   // Balayage direct
   index = 0;
   for (j=0;j<h;j++)
     for (i=0;i<w;i++) {
       RX[index]=0;
       RY[index]=0;
       if (CONTOURS[index]) { 
	 f[index]=0;
       } else {
	 f[index]=1000000;
	 for (dir=0;dir<2;dir++) {
	   switch (dir) {
	   case 0 : {
	     a=-1;b=0;
	     break;}
	   case 1 : {
	     a=0;b=-1;
	     break;}
	   }
	   sedt = p_sdet.X(i+a,j+b)+1;
	   if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	     f[index] = sedt;
	     RX[index] = p_Rx.X(i+a,j+b)+a;
	     RY[index] = p_Ry.X(i+a,j+b)+b;
	     MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	     microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	     }
	 }
       }
       index++;
     }
   // Balayage retrograde
   for (j=h-1;j>=0;j--)
     for (i=w-1;i>=0;i--) {
       index--;
       for (dir=0;dir<2;dir++) {
	 switch (dir) {
	 case 0 : {
	   a=1;b=0;
	   break;}
	 case 1 : {
	   a=0;b=1;
	   break;}
	 }
	 sedt = p_sdet.X(i+a,j+b)+1;
	 if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	   f[index] = sedt;
	   RX[index] = p_Rx.X(i+a,j+b)+a;
	   RY[index] = p_Ry.X(i+a,j+b)+b;
	   MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	   microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	 }
       }
     }
 }

void Compute_d34(Image<int>& p_macrolab,Image<int>& p_microlab,Image<int>& p_Rx,Image<int>& p_Ry,Image<int>& p_sdet) { 
  
   int h=p_macrolab.PL();
   int w=p_macrolab.PW();
   Image<int> p_contours(p_macrolab);
   int i,j,index,dir,a,b,sedt;
   int* CONTOURS=p_contours.PI();
   int* MACROLAB=p_macrolab.PI();
   int* microLAB=p_microlab.PI();
   // f : distance au pixel le + proche
   int* f=p_sdet.PI();
 // R : coordonnes relatives horiz/vert du pixel le + proche
   int* RX=p_Rx.PI();
   int* RY=p_Ry.PI();

   // Balayage direct
   index = 0;
   for (j=0;j<h;j++)
     for (i=0;i<w;i++) {
       RX[index]=0;
       RY[index]=0;
       if (CONTOURS[index]) { 
	 f[index]=0;
       } else {
	 f[index]=1000000;
	 for (dir=0;dir<4;dir++) {
	   switch (dir) {
	   case 0 : {
	     a=-1;b=0;
	     sedt = p_sdet.X(i+a,j+b)+3;
	     break;}
	   case 1 : {
	     a=-1;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+4;
	     break;}
	   case 2 : {
	     a=0;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+3;
	     break;}
	   case 3 : {
	     a=1;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+4;
	     break;}
	   }  
	   if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	     f[index] = sedt;
	     RX[index] = p_Rx.X(i+a,j+b)+a;
	     RY[index] = p_Ry.X(i+a,j+b)+b;
	     MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	     microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	     }
	 }
       }
       index++;
     }
   // Balayage retrograde
   for (j=h-1;j>=0;j--)
     for (i=w-1;i>=0;i--) {
       index--;
       for (dir=0;dir<4;dir++) {
	 switch (dir) {
	 case 0 : {
	   a=1;b=0;
	   sedt = p_sdet.X(i+a,j+b)+3;
	   break;}
	 case 1 : {
	   a=1;b=1;
	   sedt = p_sdet.X(i+a,j+b)+4;
	   break;}
	 case 2 : {
	   a=0;b=1;
	   sedt = p_sdet.X(i+a,j+b)+3;
	   break;}
	 case 3 : {
	   a=-1;b=1;
	   sedt = p_sdet.X(i+a,j+b)+4;
	   break;}
	 }
	 if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	   f[index] = sedt;
	   RX[index] = p_Rx.X(i+a,j+b)+a;
	   RY[index] = p_Ry.X(i+a,j+b)+b;
	   MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	   microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	 }
       }
     }
 }

void Compute_d5711(Image<int>& p_macrolab,Image<int>& p_microlab,Image<int>& p_Rx,Image<int>& p_Ry,Image<int>& p_sdet) { 
  
   int h=p_macrolab.PL();
   int w=p_macrolab.PW();
   Image<int> p_contours(p_macrolab);
   int i,j,index,dir,a,b,sedt;
   int* CONTOURS=p_contours.PI();
   int* MACROLAB=p_macrolab.PI();
   int* microLAB=p_microlab.PI();
   // f : distance au pixel le + proche
   int* f=p_sdet.PI();
 // R : coordonnes relatives horiz/vert du pixel le + proche
   int* RX=p_Rx.PI();
   int* RY=p_Ry.PI();

   // Balayage direct
   index = 0;
   for (j=0;j<h;j++)
     for (i=0;i<w;i++) {
       RX[index]=0;
       RY[index]=0;
       if (CONTOURS[index]) { 
	 f[index]=0;
       } else {
	 f[index]=1000000;
	 for (dir=0;dir<8;dir++) {
	   switch (dir) {
	   case 0 : {
	     a=-1;b=-2;
	     sedt = p_sdet.X(i+a,j+b)+11;
	     break;}
	   case 1 : {
	     a=1;b=-2;
	     sedt = p_sdet.X(i+a,j+b)+11;
	     break;}
	   case 2 : {
	     a=-2;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+11;
	     break;}
	   case 3 : {
	     a=-1;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+7;
	     break;}
	   case 4 : {
	     a=0;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+5;
	     break;}
	   case 5 : {
	     a=1;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+7;
	     break;}
	   case 6 : {
	     a=2;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+11;
	     break;}
	   case 7 : {
	     a=-1;b=0;
	     sedt = p_sdet.X(i+a,j+b)+5;
	     break;} 
	   }  
	   if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	     f[index] = sedt;
	     RX[index] = p_Rx.X(i+a,j+b)+a;
	     RY[index] = p_Ry.X(i+a,j+b)+b;
	     MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	     microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	     }
	 }
       }
       index++;
     }
   // Balayage retrograde
   for (j=h-1;j>=0;j--)
     for (i=w-1;i>=0;i--) {
       index--;
       for (dir=0;dir<8;dir++) {
	 switch (dir) {
	 case 0 : {
	     a=1;b=2;
	     sedt = p_sdet.X(i+a,j+b)+11;
	     break;}
	   case 1 : {
	     a=-1;b=2;
	     sedt = p_sdet.X(i+a,j+b)+11;
	     break;}
	   case 2 : {
	     a=2;b=1;
	     sedt = p_sdet.X(i+a,j+b)+11;
	     break;}
	   case 3 : {
	     a=1;b=1;
	     sedt = p_sdet.X(i+a,j+b)+7;
	     break;}
	   case 4 : {
	     a=0;b=1;
	     sedt = p_sdet.X(i+a,j+b)+5;
	     break;}
	   case 5 : {
	     a=-1;b=1;
	     sedt = p_sdet.X(i+a,j+b)+7;
	     break;}
	   case 6 : {
	     a=-2;b=1;
	     sedt = p_sdet.X(i+a,j+b)+11;
	     break;}
	   case 7 : {
	     a=1;b=0;
	     sedt = p_sdet.X(i+a,j+b)+5;
	     break;} 
	 }
	 if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	   f[index] = sedt;
	   RX[index] = p_Rx.X(i+a,j+b)+a;
	   RY[index] = p_Ry.X(i+a,j+b)+b;
	   MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	   microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	 }
       }
     }
 }

void Compute_d14203144(Image<int>& p_macrolab,Image<int>& p_microlab,Image<int>& p_Rx,Image<int>& p_Ry,Image<int>& p_sdet) { 
  
   int h=p_macrolab.PL();
   int w=p_macrolab.PW();
   Image<int> p_contours(p_macrolab);
   int i,j,index,dir,a,b,sedt;
   int* CONTOURS=p_contours.PI();
   int* MACROLAB=p_macrolab.PI();
   int* microLAB=p_microlab.PI();
   // f : distance au pixel le + proche
   int* f=p_sdet.PI();
 // R : coordonnes relatives horiz/vert du pixel le + proche
   int* RX=p_Rx.PI();
   int* RY=p_Ry.PI();

   // Balayage direct
   index = 0;
   for (j=0;j<h;j++)
     for (i=0;i<w;i++) {
       RX[index]=0;
       RY[index]=0;
       if (CONTOURS[index]) { 
	 f[index]=0;
       } else {
	 f[index]=1000000;
	 for (dir=0;dir<12;dir++) {
	   switch (dir) {
	   case 0 : {
	     a=-1;b=-3;
	     sedt = p_sdet.X(i+a,j+b)+44;
	     break;}
	   case 1 : {
	     a=1;b=-3;
	     sedt = p_sdet.X(i+a,j+b)+44;
	     break;}
	   case 2 : {
	     a=-1;b=-2;
	     sedt = p_sdet.X(i+a,j+b)+31;
	     break;}
	   case 3 : {
	     a=1;b=-2;
	     sedt = p_sdet.X(i+a,j+b)+31;
	     break;}
	   case 4 : {
	     a=-3;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+44;
	     break;}
	   case 5 : {
	     a=-2;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+31;
	     break;}
	   case 6 : {
	     a=-1;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+20;
	     break;}
	   case 7 : {
	     a=0;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+14;
	     break;}
	   case 8 : {
	     a=1;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+20;
	     break;}
	   case 9 : {
	     a=2;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+31;
	     break;}
	   case 10 : {
	     a=3;b=-1;
	     sedt = p_sdet.X(i+a,j+b)+44;
	     break;}
	   case 11 : {
	     a=-1;b=0;
	     sedt = p_sdet.X(i+a,j+b)+14;
	     break;} 
	   }  
	   if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	     f[index] = sedt;
	     RX[index] = p_Rx.X(i+a,j+b)+a;
	     RY[index] = p_Ry.X(i+a,j+b)+b;
	     MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	     microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	     }
	 }
       }
       index++;
     }
   // Balayage retrograde
   for (j=h-1;j>=0;j--)
     for (i=w-1;i>=0;i--) {
       index--;
       for (dir=0;dir<12;dir++) {
	 switch (dir) {
	  case 0 : {
	     a=1;b=3;
	     sedt = p_sdet.X(i+a,j+b)+44;
	     break;}
	   case 1 : {
	     a=-1;b=3;
	     sedt = p_sdet.X(i+a,j+b)+44;
	     break;}
	   case 2 : {
	     a=1;b=2;
	     sedt = p_sdet.X(i+a,j+b)+31;
	     break;}
	   case 3 : {
	     a=-1;b=2;
	     sedt = p_sdet.X(i+a,j+b)+31;
	     break;}
	   case 4 : {
	     a=3;b=1;
	     sedt = p_sdet.X(i+a,j+b)+44;
	     break;}
	   case 5 : {
	     a=2;b=1;
	     sedt = p_sdet.X(i+a,j+b)+31;
	     break;}
	   case 6 : {
	     a=1;b=1;
	     sedt = p_sdet.X(i+a,j+b)+20;
	     break;}
	   case 7 : {
	     a=0;b=1;
	     sedt = p_sdet.X(i+a,j+b)+14;
	     break;}
	   case 8 : {
	     a=-1;b=1;
	     sedt = p_sdet.X(i+a,j+b)+20;
	     break;}
	   case 9 : {
	     a=-2;b=1;
	     sedt = p_sdet.X(i+a,j+b)+31;
	     break;}
	   case 10 : {
	     a=-3;b=1;
	     sedt = p_sdet.X(i+a,j+b)+44;
	     break;}
	   case 11 : {
	     a=1;b=0;
	     sedt = p_sdet.X(i+a,j+b)+14;
	     break;} 
	 }
	 if ((sedt<f[index])&&(i+a>=0)&&(j+b>=0)&&(i+a<w)&&(j+b<h)) {
	   f[index] = sedt;
	   RX[index] = p_Rx.X(i+a,j+b)+a;
	   RY[index] = p_Ry.X(i+a,j+b)+b;
	   MACROLAB[index]=p_macrolab.X(i+RX[index],j+RY[index]);
	   microLAB[index]=p_microlab.X(i+RX[index],j+RY[index]);
	 }
       }
     }
 }

void Display_d48(Image<int>& p_display,Image<int>& p_sdet,int pref_color) {
  
  int i,j,index,valmax;
  int h=p_display.PL();
  int w=p_display.PW();
  int* PIX=p_display.PI();
  int* f=p_sdet.PI();
  
  index = 0;
  valmax = 0;
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      if (f[index]>valmax) valmax=f[index];
      index++;
    }
  if (pref_color) valmax = 1;
  index = 0;
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      PIX[index]=(f[index]*255)/valmax;
      index++;
    }
}

void Compute_difference(Image<int>& p_macrolab,Image<int>& p_microlab,Image<int>& p_diff,int* ListeLABELS) {
  
  int i,j,index,labelmax,distlab;
  int h=p_diff.PL();
  int w=p_diff.PW();
  int* DIF=p_diff.PI();
  int* MACROLAB=p_macrolab.PI();
  int* microLAB=p_microlab.PI();
  int a,b,newi,newj;

  index = 0;
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      DIF[index] = 0;
      labelmax = ListeLABELS[MACROLAB[index]];
      // for a 4-connected skeleton... 
    //   for (a=-1;a<=1;a++) 
// 	for (b=-1;b<=1;b++)  
// 	  if ((a!=0)||(b!=0)) {
// 	    newi = i+a;
// 	    newj = j+b;
      // for a 8-connected skeleton... 
      for (a=0;a<=1;a++)
	for (b=-1;b<=1;b+=2) {
	  newi = i+a*b;
	  newj = j+(1-a)*b;
	  if (MACROLAB[index]!= p_macrolab.X(newi,newj)) {
	    if (MACROLAB[index]> p_macrolab.X(newi,newj)) DIF[index] = 1000000;
	  } else {
	    //distlab = abs(microLAB[index]-p_microlab.X(newi,newj));
	    distlab = microLAB[index]-p_microlab.X(newi,newj);
	    if (distlab > (labelmax/2))
	      distlab = labelmax-distlab+1;
	    if (DIF[index]<distlab) DIF[index] = distlab;
	  }
	}
      index++;
    }
}

void Compute_diff2(Image<int>& p_macrolab,Image<int>& p_Rx,Image<int>& p_Ry,Image<int>& p_diff) {
  
  int i,j,index,distlab;
  int h=p_diff.PL();
  int w=p_diff.PW();
  int* DIF=p_diff.PI();
  int* MACROLAB=p_macrolab.PI();
  int a,b,newi,newj;
  int* RX=p_Rx.PI();
  int* RY=p_Ry.PI();
  
  index = 0;
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      DIF[index] = 0;
      // for a 4-connected skeleton... 
    //   for (a=-1;a<=1;a++) 
// 	for (b=-1;b<=1;b++)  
// 	  if ((a!=0)||(b!=0)) {
// 	    newi = i+a;
// 	    newj = j+b;
      // for a 8-connected skeleton... 
      for (a=0;a<=1;a++)
	for (b=-1;b<=1;b+=2) {
	  newi = i+a*b;
	  newj = j+(1-a)*b;
	  if (MACROLAB[index]!= p_macrolab.X(newi,newj)) {
	    if (MACROLAB[index]> p_macrolab.X(newi,newj)) DIF[index] = 1000000;
	  } else {
	    distlab = abs(RX[index]-p_Rx.X(newi,newj))+abs(RY[index]-p_Ry.X(newi,newj));
	    //distlab = RX[index]-p_Rx.X(newi,newj)+RY[index]-p_Ry.X(newi,newj);
	    if (DIF[index]<distlab) DIF[index] = distlab;
	  }
	}
      index++;
    }
}


void Compute_diff3(Image<int>& p_macrolab,Image<int>& p_Rx,Image<int>& p_Ry,Image<int>& p_diff) {
  
  int i,j,index,distlab;
  int h=p_diff.PL();
  int w=p_diff.PW();
  int* DIF=p_diff.PI();
  int* MACROLAB=p_macrolab.PI();
  double angle,mod1,mod2,scalpdt;
  int a,b,newi,newj;
  int* RX=p_Rx.PI();
  int* RY=p_Ry.PI();
  
  
  index = 0;
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      DIF[index] = 0;
      // for a 4-connected skeleton... 
    //   for (a=-1;a<=1;a++) 
// 	for (b=-1;b<=1;b++)  
// 	  if ((a!=0)||(b!=0)) {
// 	    newi = i+a;
// 	    newj = j+b;
      // for a 8-connected skeleton... 
      for (a=0;a<=1;a++)
	for (b=-1;b<=1;b+=2) {
	  newi = i+a*b;
	  newj = j+(1-a)*b;
	  if (MACROLAB[index]!= p_macrolab.X(newi,newj)) {
	    if (MACROLAB[index]> p_macrolab.X(newi,newj)) DIF[index] = 1000000;
	  } else {
	    if ((abs(RX[index]-p_Rx.X(newi,newj))>1)||(abs(RY[index]-p_Ry.X(newi,newj))>1)) {
	      mod1=sqrt((double)(RX[index]*RX[index])+(double)(RY[index]*RY[index]));
	      mod2=sqrt((double)(p_Rx.X(newi,newj)*p_Rx.X(newi,newj))+(double)(p_Ry.X(newi,newj)*p_Ry.X(newi,newj)));
	      scalpdt = (double)(RX[index]*p_Rx.X(newi,newj)+RY[index]*p_Ry.X(newi,newj));
	      angle = acos(scalpdt/(mod1*mod2));
	      distlab=(int)(angle*100);
	      if (DIF[index]<distlab) DIF[index] = distlab;
	    }
	  }
	}
      index++;
    }
}

void Compute_diff4(Image<int>& p_macrolab,Image<int>& p_Rx,Image<int>& p_Ry,Image<int>& p_diff) {
  
  int i,j,index,distlab;
  int h=p_diff.PL();
  int w=p_diff.PW();
  int* DIF=p_diff.PI();
  int* MACROLAB=p_macrolab.PI();
  double angle,mod1,mod2,scalpdt,dist;
  int a,b,newi,newj;
  int* RX=p_Rx.PI();
  int* RY=p_Ry.PI();
  
  
  index = 0;
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      DIF[index] = 0;
      // for a 4-connected skeleton... 
    //   for (a=-1;a<=1;a++) 
// 	for (b=-1;b<=1;b++)  
// 	  if ((a!=0)||(b!=0)) {
// 	    newi = i+a;
// 	    newj = j+b;
      // for a 8-connected skeleton... 
      for (a=0;a<=1;a++)
	for (b=-1;b<=1;b+=2) {
	  newi = i+a*b;
	  newj = j+(1-a)*b;
	  if (MACROLAB[index]!= p_macrolab.X(newi,newj)) {
	    if (MACROLAB[index]> p_macrolab.X(newi,newj)) DIF[index] = 1000000;
	  } else {
	    dist = sqrt((double)((RX[index]-p_Rx.X(newi,newj))*(RX[index]-p_Rx.X(newi,newj)))
			+ (double)((RY[index]-p_Ry.X(newi,newj))*(RY[index]-p_Ry.X(newi,newj))));
	    mod1=sqrt((double)(RX[index]*RX[index])+(double)(RY[index]*RY[index]));
	    mod2=sqrt((double)(p_Rx.X(newi,newj)*p_Rx.X(newi,newj))+(double)(p_Ry.X(newi,newj)*p_Ry.X(newi,newj)));
	    scalpdt = (double)(RX[index]*p_Rx.X(newi,newj)+RY[index]*p_Ry.X(newi,newj));
	    angle = acos(scalpdt/(mod1*mod2));
	    distlab=(int)(angle*dist);
	    if (DIF[index]<distlab) DIF[index] = distlab;
	    }
	}
      index++;
    }
}

void Display_difference(Image<int>& p_display,Image<int>& p_diff) {
  
  int i,j,index,valmax;
  int h=p_display.PL();
  int w=p_display.PW();
  int* PIX=p_display.PI();
  int* DIF=p_diff.PI();

  index = 0;
  valmax = 0;
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) { 
      if ((DIF[index]>valmax)&&(DIF[index]!=1000000)) 
	valmax=DIF[index];
      index++;
    }
  printf("valmax = %d\n\n",valmax);
  index = 0;
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      if (DIF[index]!=1000000)
	PIX[index]=(DIF[index]*255)/valmax;
      else PIX[index]=501;
      index++;
    }
}

void Unroll_mlabels(Image<int>& p_display,Image<int>& p_microlab,int Threshold) {
  int i,j,index;
  int h=p_display.PL();
  int w=p_display.PW();
  int* PIX=p_display.PI();
  int* lab=p_microlab.PI();

  index = 0;
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      if (lab[index]>Threshold) 
	PIX[index] = 255;
      else PIX[index] = 0;
      index++;
    }
}



void Compute_Skeleton(Image<int>& p_display,Image<int>& p_diff,Image<int>& p_original,int Threshold) {
  
  int i,j,index;
  int h=p_display.PL();
  int w=p_display.PW();
  int* PIX=p_display.PI();
  int* DIF=p_diff.PI();
  int* ORI=p_original.PI();

  index = 0;
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      if (DIF[index]>Threshold) 
	if (ORI[index])
	  PIX[index] = 501;
	else 
	  PIX[index] = 504;
      else 
	if (ORI[index])
	  PIX[index] = 180;
      else 
	PIX[index] = 255;
      index++;
    }
}

void Compute_reconstruction_old(Image<int>& p_display,Image<int>& p_original,Image<int>& p_diff,Image<int>& p_sedt,int distance,int Threshold) { 
  
   int h=p_original.PL();
   int w=p_original.PW();
   int i,j,x,y,a,b;
   FIFO f(w*h);
   int index=0;
   int rayon,cond;
   int* DIST=p_sedt.PI();
   int* PIX=p_display.PI();
   int* DIF=p_diff.PI();
   int* ORI=p_original.PI();
   
   // Initialisation FIFO...
   for (j=0;j<h;j++)
     for (i=0;i<w;i++) {
       PIX[index]=0;
       if ((ORI[index])&&(DIF[index]>=Threshold))
	 f.FIFO_add(i,j);
       index++;
     }
   while (!f.FIFO_empty()) {
     f.FIFO_get(x,y);
     if (distance==1) rayon=(int)sqrt((double)p_sedt.X(x,y)); else rayon=p_sedt.X(x,y);
     for (j=-rayon;j<=rayon;j++) 
       for (i=-rayon;i<=rayon;i++) {
	 a = x+i;b = y+j;
	 if ((a>=0)&&(b>=0)&&(a<w)&&(b<h))
	   index = b*w+a;
	 if (distance == 1) cond = (i*i + j*j <= rayon*rayon);
	 else 
	   if (distance == 4) cond = (abs(i) + abs(j) <= rayon); 
	   else cond = 1;
	 if ((!PIX[index])&&(cond))
	   PIX[index]=255;
       }
   }
}
    
void Compute_reconstruction_map(Image<int>& p_recomap,Image<int>& p_original,Image<int>& p_diff,Image<int>& p_sedt,int distance) { 
  
   int h=p_original.PL();
   int w=p_original.PW();
   int i,j,x,y,a,b;
   FIFO f(w*h);
   int index=0;
   int rayon,cond,bbox;
   int* DIST=p_sedt.PI();
   int* PIX=p_recomap.PI();
   int* DIF=p_diff.PI();
   int* ORI=p_original.PI();
   
   // Initialisation FIFO...
   for (j=0;j<h;j++)
     for (i=0;i<w;i++) {
       PIX[index]=0;
       if ((ORI[index])&&(DIF[index]>1))
	 f.FIFO_add(i,j);
       index++;
     }
   while (!f.FIFO_empty()) {
     f.FIFO_get(x,y);
     rayon=p_sedt.X(x,y);
     if (distance==1) bbox=(int)sqrt((double)rayon)+1; else bbox=rayon;
     for (j=-bbox;j<=bbox;j++) 
       for (i=-bbox;i<=bbox;i++) {
	 a = x+i;b = y+j;
	 if ((a>=0)&&(b>=0)&&(a<w)&&(b<h))
	   index = b*w+a;
	 if (distance == 1) cond = (i*i + j*j <= rayon);
	 else 
	   if (distance == 4) cond = (abs(i) + abs(j) <= rayon); 
	   else cond = 1;
	 if (cond)
	   PIX[index]=MAX(PIX[index],p_diff.X(x,y));
       }
   }
}

void Compute_reconstruction(Image<int>& p_display,Image<int>& p_recomap,int Threshold) {
  
  int i,j,index;
  int h=p_display.PL();
  int w=p_display.PW();
  int* PIX=p_display.PI();
  int* REC=p_recomap.PI();

  index = 0;
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      if (REC[index]>=Threshold) 
	PIX[index] = 255;
      else PIX[index] = 0;
      index++;
    }
}

void Display_reco(Image<int>& p_display,Image<int>& p_reco,int pref_color) {
  
  int i,j,index,valmax;
  int h=p_display.PL();
  int w=p_display.PW();
  int* PIX=p_display.PI();
  int* r=p_reco.PI();
  
  if (pref_color) valmax = 1;
  else {
    index = 0;
    valmax = 0;
    for (j=0;j<h;j++)
      for (i=0;i<w;i++) {
	if ((r[index]<1000000)&&(r[index]>valmax)) valmax=r[index];
	index++;
      }
  }
  index = 0;
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      if (r[index]<1000000)
	PIX[index]=(r[index]*255)/valmax;
      else PIX[index]=501;
      index++;
    }
}
